
SRCS_BIN = $(foreach dir, app, $(wildcard $(dir)/*/*/bin))

SRCS_CNF = $(subst bin,configs,$(SRCS_BIN))

# 打包版本号
PKG_VERSION ?= 1.1.1

# 打包文件名
PKG_FILENAME = server-v$(PKG_VERSION).tar.gz

# gitlab 项目ID
PROJECT_ID = 46

# gitlab access token
ACCESS_TOKEN = NjpV_yjRSf7H3UfkJo8G

# base url
BASEURL = http://gitlab.preclight.com

# resource url
RESOURCE_URL = $(BASEURL)/cabin/server$(TARGET_URL)

# 获取上传结果
TARGET_URL = $(shell curl --request POST --header "PRIVATE-TOKEN: $(ACCESS_TOKEN)" --form "file=@$(PKG_FILENAME)" \
				$(BASEURL)/api/v4/projects/$(PROJECT_ID)/uploads \
				| grep -woP '.{0,1}markdown.{0,200}' | grep -oE '\/(.*).gz')


# 项目打包
.PHONY: package
package: build
	mkdir -p release/mc-service release/mc-client;

	$(foreach dir, $(realpath $(SRCS_BIN)),\
      $(if $(findstring control, $(dir)),\
      	cp -r $(dir)/* release/mc-service;, \
      	cp -r $(dir)/* release/mc-client; \
      ) \
    )

	$(foreach dir, $(realpath $(SRCS_CNF)),\
		$(if $(findstring control, $(dir)),\
			cp -r $(dir) release/mc-service;, \
			cp -r $(dir) release/mc-client; \
		) \
	  )

	cd release && tar -czvf ../$(PKG_FILENAME) *;
	rm -rf release;

# 发布程序
.PHONY: release
release: package
	curl --header 'Content-Type: application/json' --header "PRIVATE-TOKEN: $(ACCESS_TOKEN)" \
		 --data '{"name":"v$(PKG_VERSION)","tag_name":"v$(PKG_VERSION)","description":"Super nice release","assets":{"links":[{"name":"$(PKG_FILENAME)","url":"$(RESOURCE_URL)"}]}}' \
		 --request POST $(BASEURL)/api/v4/projects/$(PROJECT_ID)/releases

	@rm -rf $(PKG_FILENAME)